#include <CGAL/basic.h>
#include <CGAL/Cartesian.h>
#include <CGAL/Point_2.h>
#include <CGAL/convex_hull_2.h>

typedef   CGAL::Point_2<CGAL::Cartesian<double> >        Point_2;

int
main()
{
  std::istream_iterator< Point_2 >  in_start( std::cin );
  std::istream_iterator< Point_2 >  in_end;
  std::ostream_iterator< Point_2 >  out( std::cout, "\n" );
  CGAL::convex_hull_points_2( in_start, in_end, out );
  return 0;
}

